use gtk::traits::OrientableExt;
use relm4::prelude::*;

use crate::app_msg::*;

#[derive(Debug, PartialEq, Eq, PartialOrd, Ord)]
pub struct LibraryListItem {
    name: String,
}

#[relm4::factory(pub)]
impl FactoryComponent for LibraryListItem {
    type Init = String;
    type Input = ();
    type Output = ();
    type CommandOutput = ();
    type ParentInput = AppMsg;
    type ParentWidget = gtk::ListBox;

    view! {
        gtk::Box {
            set_orientation: gtk::Orientation::Horizontal,
            gtk::Label {
                set_label: &self.name,
            }
        }
    }

    fn init_model(name: Self::Init, _index: &DynamicIndex, _sender: FactorySender<Self>) -> Self {
        Self { name }
    }
}
